import "core-js/modules/es6.regexp.match";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import React, { Component } from 'react';

require('./index.css');

var _default =
/*#__PURE__*/
function (_Component) {
  _inherits(_default, _Component);

  function _default(props) {
    var _this;

    _classCallCheck(this, _default);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(_default).call(this, props)); // this.handlebutton = this.handlebutton.bind(this);

    _this.addFalse = function (index) {
      return function (event) {
        if (!_this.props.closeIcon) return;

        if (_this.state.dataSource.length != 1) {
          //hover中的selectButton
          var hoverButton = document.getElementsByClassName('selectbuttton_false');
          hoverButton[index].style.opacity = 1;
        }
      };
    };

    _this.clickFork = function (index) {
      return function (e) {
        //在react中阻止默认事件与冒泡不能直接使用stopPropagation，preventDefault
        e.nativeEvent.stopPropagation();
        e.preventDefault(); //dataFork为事件抛出函数

        if (_this.props.clickCloselcon) {
          _this.props.clickCloselcon(index, _this.state.dataSource[index]);
        }
      };
    };

    _this.aClick = function (index) {
      return function (e) {
        if (_this.props.cancel) {
          e.preventDefault();

          if (_this.props.fickClick) {
            _this.props.fickClick(_this.state.dataSource[index]);
          }

          return;
        }
      };
    };

    _this.cancalFalse = function (index) {
      return function (event) {
        if (!_this.props.closeIcon) return; //hover中的selectButton

        var hoverButton = document.getElementsByClassName('selectbuttton_false')[index];
        hoverButton.style.opacity = 0;
      };
    };

    _this.onArrowClick = _this.onArrowClick.bind(_assertThisInitialized(_this)); //鼠标hover时出现删除操作
    // this.addFalse = this.addFalse.bind(this);
    // this.cancalFalse = this.cancalFalse.bind(this);
    // //鼠标点击hover时删除
    // this.clickFork = this.clickFork.bind(this);

    _this.state = {
      dataSource: _this.props.dataSource
    };
    return _this;
  }

  _createClass(_default, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        var activeLeft = _this2.activeBtn.offsetLeft; //一页的长度

        var pageLen = _this2.contentDom.offsetWidth; //可以滚动的距离

        var distances = _this2.scrollDom.offsetWidth - pageLen; //可以滚动的总页数

        var pages = Math.abs(distances / pageLen); //当前页数

        var page = activeLeft / pageLen;

        if (pages <= 1) {
          document.getElementsByClassName('arrow left')[0].style.display = 'none';
          document.getElementsByClassName('arrow right')[0].style.display = 'none';
        }

        if (distances > 0) {
          _this2.scrollDom.className = 'scroll-content leftalign';
        }

        if (activeLeft > pageLen) {
          _this2.scrollDom.style.left = "-".concat(page + 1 >= pages ? Math.abs(distances) : (page + 1) * pageLen, "px");
        }
      }, 500);
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        'dataSource': nextProps.dataSource
      });
    }
  }, {
    key: "handlebutton",
    value: function handlebutton(point) {
      var _this3 = this;

      this.state.dataSource.forEach(function (data, index) {
        data[_this3.props.activeFieldName] = point === index ? true : false;
      });
      this.setState({
        dataSource: this.state.dataSource
      });
      this.props.stateChange ? this.props.stateChange(this.props.dataSource[key]) : null;
    }
    /**
    * 滚动按钮点击事件：点击一次滚动一页，不够一页滚动剩余部分
    */

  }, {
    key: "onArrowClick",
    value: function onArrowClick(e) {
      if (this.distances <= 0) {
        return;
      } //可以滚动的距离


      this.distances = this.scrollDom.offsetWidth - this.contentDom.offsetWidth; //可以滚动的总页数

      this.pages = Math.abs(this.distances / this.contentDom.offsetWidth); //一页的长度

      this.pageLen = this.contentDom.offsetWidth;

      if (this.distances <= 0) {
        this.refs.arrowL.style.visibility = 'hidden';
        this.refs.arrowR.style.visibility = 'hidden';
      } //是否点击右侧按钮


      var isRight = e.target && e.target.className.match('right'); //需要滚动元素left值

      var domLeft = Math.abs(parseInt(this.scrollDom.style.left || 0)); //当前页数

      var page = domLeft / this.contentDom.offsetWidth;
      this.scrollDom.style.left = '-' + (isRight ? page + 1 >= this.pages ? Math.abs(this.distances) : (page + 1) * this.pageLen : page - 1 <= 0 ? 0 : (page - 1) * this.pageLen) + 'px';
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      return React.createElement("div", {
        className: "selectbuttontop-container"
      }, React.createElement("div", {
        className: "arrow left",
        ref: "arrowL",
        onClick: this.onArrowClick
      }), React.createElement("div", {
        className: "content",
        ref: function ref(content) {
          _this4.contentDom = content;
        }
      }, React.createElement("div", {
        className: "scroll-content",
        ref: function ref(scroll) {
          _this4.scrollDom = scroll;
        }
      }, this.state.dataSource.map(function (ele, index) {
        if (ele.disable) {
          return React.createElement("div", null, React.createElement("a", {
            tabIndex: index,
            key: index,
            className: "".concat(ele[_this4.props.activeFieldName] && 'active', " disable"),
            ref: function ref(activeBtn) {
              if (ele[_this4.props.activeFieldName]) {
                _this4.activeBtn = activeBtn;
              }

              ;

              if (_this4.state.dataSource.length - 1 === index) {
                _this4.lastBtn = activeBtn;
              }
            }
          }, React.createElement("span", {
            className: "disable_zi"
          }, " ", ele[_this4.props.fieldName])), _this4.props.closeIcon && React.createElement("span", {
            className: "selectbuttton_false",
            onClick: _this4.clickFork(index)
          }));
        } else return React.createElement("div", null, React.createElement("a", {
          href: ele[_this4.props.linkFieldName],
          tabIndex: index,
          key: index,
          onClick: _this4.aClick(index),
          onMouseEnter: _this4.addFalse(index),
          onMouseLeave: _this4.cancalFalse(index),
          className: "".concat(ele[_this4.props.activeFieldName] && 'active', " default"),
          ref: function ref(activeBtn) {
            if (ele[_this4.props.activeFieldName]) {
              _this4.activeBtn = activeBtn;
            }

            ;

            if (_this4.state.dataSource.length - 1 === index) {
              _this4.lastBtn = activeBtn;
            }
          }
        }, ele[_this4.props.fieldName]), _this4.props.closeIcon && React.createElement("span", {
          className: "selectbuttton_false",
          onClick: _this4.clickFork(index),
          onMouseEnter: _this4.addFalse(index),
          onMouseLeave: _this4.cancalFalse(index)
        }));
      }))), React.createElement("div", {
        className: "arrow right",
        ref: "arrowR",
        onClick: this.onArrowClick
      }));
    }
  }]);

  return _default;
}(Component);

export { _default as default };